import time
import datetime
import pickle 
import sys
import os
sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), '..')))
from TIRAMISU import read_model_new as rm
from TIRAMISU import make_translation as mt
from TIRAMISU import add_and_write_mechanism as awm
with open(sys.argv[1], 'r') as file_input :
    file = file_input.readlines()
# with open("0.txt", 'r') as file_input :
#     file = file_input.readlines()
file=[x for x in file if x.strip()[0] != '!']
file=[x for x in file if x.strip() != '']
c_path=[x.strip() for x in file[0].split()]
c_path=[c_path[0]+x if x!=c_path[0] else x for x in c_path]
if len(c_path)==4 :
    core_path, path_mech_core, path_therm_core, path_trans_core=c_path[0], c_path[1], c_path[2], c_path[3]
elif len(c_path) == 3 :
    core_path, path_mech_core, path_therm_core=c_path[0], c_path[1], c_path[2]
    path_trans_core=''
else :
    raise Exception(f'Error in core path mechanism (mech1).\nThe first line should contain the path to the mechanism and the name of the mech file, the therm file and if there is one, the transport file.\n{file[0]}')
t_path=[x.strip() for x in file[1].split()]
t_path=[t_path[0]+x if x!=t_path[0] else x for x in t_path]
if len(t_path)==4 :
    translate_path, path_mech_to_translate, path_therm_to_translate, path_trans_to_translate=t_path[0], t_path[1], t_path[2], t_path[3]
elif len(t_path) == 3 :
    translate_path, path_mech_to_translate, path_therm_to_translate=t_path[0], t_path[1], t_path[2]
    path_trans_to_translate=''
else :
    raise Exception(f'Error in translate path mechanism (mech2).\nThe second line should contain the path to the mechanism and the name of the mech file, the therm file and if there is one, the transport file.\n{file[1]}')

name_core=os.path.basename(path_mech_core).split('.')[0]
name_translate=os.path.basename(path_mech_to_translate).split('.')[0]

output=file[2].strip()
n=10000
n_find=False
do_translation=True
translation_find=False
for line in file :
    if "n=" in line[:2].strip() :
        n_find=True
        n=int(line.strip()[2:])
    if "translation=" in line.strip()[:12] :
        translation_find=True
        tmp_bool=(line.strip()[12:]).casefold()
        if 'true' in tmp_bool :
            do_translation=True
        elif 'false'in tmp_bool :
            do_translation=False
        else :
            raise Exception('Error: translation keyword not True nor False.')
        
if n_find is False :
    print('No maximum number of permutation specified (n=). Default is n=10000.')
if translation_find is False :
    print('No boolean for translation (translation=True or False). Default is translation=True.')
print(f'\ntranslation={do_translation}')

time_start = time.time()

model_to_translate=rm.Model(path_mech_to_translate, path_therm_to_translate, output, path_trans_to_translate,verbose=False)
model_core=rm.Model(path_mech_core, path_therm_core, output, path_trans_core, verbose=False)

time_end = time.time()

print(f'\nTotal time for model compilation = {time_end-time_start} seconds or {datetime.timedelta(seconds=(time_end-time_start))} ')
print( f'\nmodel_to_translate Species = {len(model_to_translate.reactions[1])} Reactions = {len(model_to_translate.reactions[2])}')
print( f'\nmodel_core Species = {len(model_core.reactions[1])} Reactions = {len(model_core.reactions[2])}')

with open(f'{output}{name_translate}.pick', 'wb') as m1 :
    pickle.dump( model_to_translate, m1)
with open(f'{output}{name_core}.pick', 'wb') as m2 :
    pickle.dump(model_core, m2)

if do_translation is True :
    time_start = time.time()
    stock=mt.models_translation(model_to_translate,  model_core, output, 350, n)
    time_end=time.time()
    print(f'\nTotal time = {time_end-time_start} seconds or {datetime.timedelta(seconds=(time_end-time_start))} ')
    
print('\n\nOpen and complete translation in "tmp_species_traduction.tmp". Then change name to "tmp_species_traduction.inp".\nEND OF PART 1')